
/**************************************************************************************************|
|* Copyright 2020 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY17P6X Series                                                               *|
|**************************************************************************************************/
#include <INT.h>           // Interrupt Config for ADC
#include <CLK.h>           // CLK Cpnfig for ADC
#include <PWR.h>           // NET Cpnfig for ADC
/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
//// AD1CN0 //
// Bit-field Struc Test for SDCC
#define ENAD1                     7
#define ENAD1_MSK                (1 << ENAD1)
#define ENAD1_ENABLE             (1 << ENAD1)
#define ENAD1_DISABLE            (0 << ENAD1)

#define VREGN                     4
#define VREGN_MSK                (1 << VREGN)
#define VREGN_DIV2               (1 << VREGN)
#define VREGN_DIV1               (0 << VREGN)

#define OSR                       1
#define OSR_MSK                  (7 << OSR)
#define OSR_61440                ( 7 << OSR)
#define OSR_30720                ( 6 << OSR)
#define OSR_15360                ( 5 << OSR)
#define OSR_7680                 ( 4 << OSR)
#define OSR_256                  ( 3 << OSR)
#define OSR_128                  ( 2 << OSR)
#define OSR_64                   ( 1 << OSR)
#define OSR_32                   ( 0 << OSR)

#define CMFR                      0
#define CMFR_MSK                 (1 << CMFR)
#define CMFR_ENABLE              (1 << CMFR)
#define CMFR_DISABLE             (0 << CMFR)

//// AD1CN1 //
#define ENACM                     7
#define ENACM_MSK                (1 << ENACM)
#define ENACM_ENABLE             (1 << ENACM)
#define ENACM_DISABLE            (0 << ENACM)

#define VCMS                      6
#define VCMS_MSK                 (1 << VCMS)
#define VCMS_EXTERNAL            (1 << VCMS)
#define VCMS_INTERNAL            (0 << VCMS)

#define VCINS                     5
#define VCINS_MSK                (1 << VCINS)
#define VCINS_VDDADIV2           (1 << VCINS)
#define VCINS_V12                (0 << VCINS)

#define TPSCH                     4
#define TPSCH_MSK                (1 << TPSCH)
#define TPSCH_ENABLE            (1 << TPSCH)
#define TPSCH_DISABLE             (0 << TPSCH)

#define ADGN                      0
#define ADGN_MSK                 (7 << ADGN)
#define ADGN_RSVD                (7 << ADGN)
//#define ADGN_RSVD                (6 << ADGN)
#define ADGN_8                   (5 << ADGN)
#define ADGN_4                   (4 << ADGN)
#define ADGN_2                   (3 << ADGN)
#define ADGN_1                   (2 << ADGN)
#define ADGN_1DIV2               (1 << ADGN)
//#define ADGN_RSVD                (0 << ADGN)

 
//// AD1CN2 //
#define DCSET                     0
#define DCSET_MSK                (15 << DCSET)
#define DCSET_N7DIV8             (15 << DCSET)
#define DCSET_N6DIV8             (14 << DCSET)
#define DCSET_N5DIV8             (13 << DCSET)
#define DCSET_N4DIV8             (12 << DCSET)
#define DCSET_N3DIV8             (11 << DCSET)
#define DCSET_N2DIV8             (10 << DCSET)
#define DCSET_N1DIV8             ( 9 << DCSET)
#define DCSET_N0                 ( 8 << DCSET)
#define DCSET_P7DIV8             ( 7 << DCSET)
#define DCSET_P6DIV8             ( 6 << DCSET)
#define DCSET_P5DIV8             ( 5 << DCSET)
#define DCSET_P4DIV8             ( 4 << DCSET)
#define DCSET_P3DIV8             ( 3 << DCSET)
#define DCSET_P2DIV8             ( 2 << DCSET)
#define DCSET_P1DIV8             ( 1 << DCSET)
#define DCSET_P0                 ( 0 << DCSET)

// AD1CN3 //
#define SAD1FP                    4
#define SAD1FP_MSK               (15 << SAD1FP)
//#define SAD1FP_                (15 << SAD1FP)
//#define SAD1FP_                (14 << SAD1FP)
//#define SAD1FP_                (13 << SAD1FP)
//#define SAD1FP_                (12 << SAD1FP)
//#define SAD1FP_                (11 << SAD1FP)            
#define SAD1FP_PB4               0xA0 //(10 << SAD1FP)
#define SAD1FP_PB2               0x90 //( 9 << SAD1FP)
//#define SAD1FP_                ( 8 << SAD1FP)
#define SAD1FP_PB0               ( 7 << SAD1FP)
//#define SAD1FP_                ( 6 << SAD1FP)
#define SAD1FP_REFO              ( 5 << SAD1FP)
#define SAD1FP_VDDA              ( 4 << SAD1FP)
#define SAD1FP_OP1O              ( 3 << SAD1FP)
//#define SAD1FP_                ( 2 << SAD1FP)
//#define SAD1FP_                ( 1 << SAD1FP)
//#define SAD1FP_                ( 0 << SAD1FP)

#define SAD1FN                    0
#define SAD1FN_MSK               (7 << SAD1FN)
//#define SAD1FN_                (7 << SAD1FN)
#define SAD1FN_PB4               (6 << SAD1FN)
#define SAD1FN_PB3               (5 << SAD1FN)
#define SAD1FN_PB2               (4 << SAD1FN)
#define SAD1FN_AGND              (3 << SAD1FN)
#define SAD1FN_VSS               (2 << SAD1FN)
//#define SAD1FN_                (1 << SAD1FN)
//#define SAD1FN_                (0 << SAD1FN)

// AD1CN4 //
#define AD1RHBUF                     7
#define AD1RHBUF_MSK                (1 << AD1RHBUF)
#define AD1RHBUF_ENABLE             (1 << AD1RHBUF)
#define AD1RHBUF_DISABLE            (0 << AD1RHBUF)

#define AD1RLBUF                     6
#define AD1RLBUF_MSK                (1 << AD1RLBUF)
#define AD1RLBUF_ENABLE             (1 << AD1RLBUF)
#define AD1RLBUF_DISABLE            (0 << AD1RLBUF)

#define AD1IPBUF                     5
#define AD1IPBUF_MSK                (1 << AD1IPBUF)
#define AD1IPBUF_ENABLE             (1 << AD1IPBUF)
#define AD1IPBUF_DISABLE            (0 << AD1IPBUF)

#define AD1INBUF                     4
#define AD1INBUF_MSK                (1 << AD1INBUF)
#define AD1INBUF_ENABLE             (1 << AD1INBUF)
#define AD1INBUF_DISABLE            (0 << AD1INBUF)

#define INX                          2 
#define INX_MSK                     (3 << INX)
#define INX_CROSS                   (3 << INX)
#define INX_INP                     (2 << INX)
#define INX_INN                     (1 << INX)
#define INX_NORMAL                  (0 << INX)

//// AD1CN5
#define SAD1RH                      5
#define SAD1RH_MSK                 (7 << SAD1RH)
//#define SAD1RH_                    (7 << SAD1RH)
#define SAD1RH_AGND                (6 << SAD1RH)
#define SAD1RH_VDDA                (5 << SAD1RH)
//#define SAD1RH_                    (4 << SAD1RH)
#define SAD1RH_PB4                 (3 << SAD1RH)
//#define SAD1RH_                    (2 << SAD1RH)
#define SAD1RH_REFO                (1 << SAD1RH)
//#define SAD1RH_                    (0 << SAD1RH)

#define SAD1RL                      2
#define SAD1RL_MSK                 (7 << SAD1RL)
//#define SAD1RL_                    (7 << SAD1RL)
//#define SAD1RL_                    (6 << SAD1RL)
#define SAD1RL_VSS                 (5 << SAD1RL)
//#define SAD1RL_                    (4 << SAD1RL)
//#define SAD1RL_                    (3 << SAD1RL)
#define SAD1RL_PB3                 (2 << SAD1RL)
#define SAD1RL_AGND                (1 << SAD1RL)
//#define SAD1RL_                    (0 << SAD1RL)

#define SAD1I                       0
#define SAD1I_MSK                  (3 << SAD1I)
#define SAD1I_TS1N_TS2P            (3 << SAD1I)
#define SAD1I_TS1P_TS2N            (2 << SAD1I)
//#define SAD1I_                     (1 << SAD1I)
#define SAD1I_AD1FP_AD1FN          (0 << SAD1I)

#define TS1N    0
#define TS2P    0
#define TS1P    1
#define TS2N    1
/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
#define ADC_CLK_DivSelect(DADCSel)      (OSCCN1 = (OSCCN1 & (~DADC_MSK)) | DADCSel)
//#define CLK_ADCCKDivSel(ADCDivSel)      (OSCCN1 = ((OSCCN1 & (~DADC_MSK)) | ADCDivSel))

#define ADC_SDIOShort()                 (NET0 |= SDIO_SHORT)
#define ADC_SDIOOpen()                  (NET0 &= (~SDIO_MSK))
#define ADC_SFT1Select(Sel)             (NET0 = ((NET0 & (~SFT1_MSK)) | Sel))
//#define PWR_SDIOShort()                 (NET0 |= SDIO_SHORT)
//#define PWR_SDIOOpen()                  (NET0 &= (~SDIO_MSK))
//#define PWR_SFT1Select(Sel)             (NET0 = ((NET0 & (~SFT1_MSK)) | Sel))

#define ADC_ENTPSEnable()               (PWRCN2 |= ENTPS_ENABLE)
#define ADC_ENTPSDisable()              (PWRCN2 &= (~ENTPS_MSK))
//#define PWR_ENTPSEnable()               (PWRCN2 |= ENTPS_ENABLE)
//#define PWR_ENTPSDisable()              (PWRCN2 &= (~ENTPS_MSK))

#define ADC_INT_Enable()                (INTE0 |= ADIE_ENABLE)
#define ADC_INT_Disable()               (INTE0 &= (~ADIE_MSK))
#define ADC_INT_IsFlag()                (INTF0 & ADIF_SET)
#define ADC_INT_ClearFlag()             (INTF0 &= (~ADIF_MSK))
//#define ADIE_Enable()               (INTE0 |= ADIE_ENABLE)
//#define ADIE_Disable()              (INTE0 &= (~ADIE_MSK))
//#define ADIF_IsFlag()               (INTF0 & ADIF_SET)
//#define ADIF_ClearFlag()            (INTF0 &= (~ADIF_MSK))

#define AD1CN0_SET(AD1CN0Sel)           (AD1CN0 |= (1<<AD1CN0Sel))
#define AD1CN0_CLR(AD1CN0Sel)           (AD1CN0 &= ~(1<<AD1CN0Sel))
#define ADC_Enable()                    (AD1CN0 |= ENAD1_ENABLE)
#define ADC_Disable()                   (AD1CN0 &= (~ENAD1_MSK))  
#define ADC_VREGNDiv2()                 (AD1CN0 |= VREGN_DIV2)
#define ADC_VREGNDiv1()                 (AD1CN0 &= ~(VREGN_MSK))
#define ADC_VREGNSelect(VREGNSel)       (AD1CN0 = ((AD1CN0 & (~VREGN_MSK)) | VREGNSel))
#define ADC_OSRSelect(OSRSel)           (AD1CN0 = (AD1CN0 & (~OSR_MSK)) | OSRSel)
#define ADC_CMFREnable()                (AD1CN0 |= CMFR_ENABLE)
#define ADC_CMFRDisable()               (AD1CN0 &= (~CMFR_MSK))

#define AD1CN1_SET(AD1CN1Sel)           (AD1CN1 |= (1<<AD1CN1Sel))
#define AD1CN1_CLR(AD1CN1Sel)           (AD1CN1 &= ~(1<<AD1CN1Sel))
#define ADC_ENACMEnable()               (AD1CN1 |= ENACM_ENABLE)
#define ADC_ENACMDisable()              (AD1CN1 &= (~ENACM_MSK))
#define ADC_VCMSSelect(VCMSel)          (AD1CN1 = ((AD1CN1 & (~VCMS_MSK))|VCMSel))
#define ADC_ACMSource(ACMSel)           (AD1CN1 = ((AD1CN1 & (~VCINS_MSK)) | ACMSel))
#define ADC_TPSCHEnable()               (AD1CN1 |= TPSCH_ENABLE)
#define ADC_TPSCHDisable()              (AD1CN1 &= (~TPSCH_MSK))
#define ADC_ADGNSelect(adgn)            (AD1CN1 = ((AD1CN1 & (~ADGN_MSK))|adgn))

#define AD1CN2_SET(AD1CN2Sel)           (AD1CN2 |= (1<<AD1CN2Sel))
#define AD1CN2_CLR(AD1CN2Sel)           (AD1CN2 &= ~(1<<AD1CN2Sel))
#define ADC_DCSETSelect(dcset)          (AD1CN2 = ((AD1CN2 & (~DCSET_MSK)) | dcset))

#define AD1CN3_SET(AD1CN3Sel)           (AD1CN3 |= (1<<AD1CN3Sel))
#define AD1CN3_CLR(AD1CN3Sel)           (AD1CN3 &= ~(1<<AD1CN3Sel))
#define ADC_AD1FSelect(sadfp,sadfn)     (AD1CN3 = ((AD1CN3 & (~(SAD1FP_MSK | SAD1FN_MSK))) | (sadfp | sadfn)))

#define AD1CN4_SET(AD1CN4Sel)           (AD1CN4 |= (1<<AD1CN4Sel))
#define AD1CN4_CLR(AD1CN4Sel)           (AD1CN4 &= ~(1<<AD1CN4Sel))
#define ADC_VRBufferCtrl(vrh,vrl)       (AD1CN4 = ((AD1CN4 & (~(AD1RHBUF_MSK | AD1RLBUF_MSK))) | (vrh | vrl)))
#define ADC_VRHBufferEnable()           (AD1CN4 |= AD1RHBUF_ENABLE)
#define ADC_VRHBufferDisable()          (AD1CN4 &= (~AD1RHBUF_MSK))
#define ADC_VRLBufferEnable()           (AD1CN4 |= AD1RLBUF_ENABLE)
#define ADC_VRLBufferDisable()          (AD1CN4 &= (~AD1RLBUF_MSK))
#define ADC_INBufferCtrl(inp,inn)       (AD1CN4 = ((AD1CN4 & (~(AD1IPBUF_MSK | AD1INBUF_MSK))) | (inp | inn)))
#define ADC_INPBufferEnable()           (AD1CN4 |= AD1IPBUF_ENABLE)
#define ADC_INPBufferDisable()          (AD1CN4 &= (~AD1IPBUF_MSK))
#define ADC_INNBufferEnable()           (AD1CN4 |= AD1INBUF_ENABLE)
#define ADC_INNBufferDisable()          (AD1CN4 &= (~AD1INBUF_MSK))
#define ADC_INXSelect(INXSel)           (AD1CN4 = ((AD1CN4 & (~INX_MSK)) | INXSel))

#define AD1CN5_SET(AD1CN5Sel)           (AD1CN5 |= (1<<AD1CN5Sel))
#define AD1CN5_CLR(AD1CN5Sel)           (AD1CN5 &= ~(1<<AD1CN5Sel))
#define ADC_VRINSelect(vrh,vrl)         (AD1CN5 = ((AD1CN5 & (~(SAD1RH_MSK | SAD1RL_MSK))) | (vrh | vrl)))
#define ADC_VINSelect(VINSel)          (AD1CN5 = ((AD1CN5 & (~SAD1I_MSK)) | VINSel))


/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/

void ADC_Open(unsigned char ck,        //Prescaler of SD18 peripheral operating frequency
              unsigned char inh,        //SI+ input signal selector
              unsigned char inl,        //SI- input signal selector
              unsigned char vrh,        //VR+ voltage signal selector
              unsigned char vrl,        //VR- voltage signal selector
              unsigned char adgn,       //AD amplification adjuster
              unsigned char vrgn,       //VR amplification adjuster
              unsigned char dcset,      //SI+/- bias adjuster
              unsigned char osr);       //SD18 over-sampling rate divider
long ADC_GetData(void);

