/**************************************************************************************************|
|* Copyright 2020 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY17P6X Series                                                                 *|
|**************************************************************************************************/

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
//// PT1 //
#define PT10                      0
#define PT10_MSK                 (1 << PT10)
#define PT10_H                   (1 << PT10)
#define PT10_L                   (0 << PT10)
#define PT11                      1
#define PT11_MSK                 (1 << PT11)
#define PT11_H                   (1 << PT11)
#define PT11_L                   (0 << PT11)
#define PT12                      2  
#define PT12_MSK                 (1 << PT12)
#define PT12_H                   (1 << PT12)
#define PT12_L                   (0 << PT12)
#define PT13                      3
#define PT13_MSK                 (1 << PT13)
#define PT13_H                   (1 << PT13)
#define PT13_L                   (0 << PT13)
#define PT14                      4
#define PT14_MSK                 (1 << PT14)
#define PT14_H                   (1 << PT14)
#define PT14_L                   (0 << PT14)
#define PT15                      5
#define PT15_MSK                 (1 << PT15)
#define PT15_H                   (1 << PT15)
#define PT15_L                   (0 << PT15)
#define PT16                      6
#define PT16_MSK                 (1 << PT16)
#define PT16_H                   (1 << PT16)
#define PT16_L                   (0 << PT16)
#define PT17                      7
#define PT17_MSK                 (1 << PT17)
#define PT17_H                   (1 << PT17)
#define PT17_L                   (0 << PT17)

//// TRISC1 //
#define TC10                      0
#define TC10_MSK                 (1 << TC10)
#define TC10_H                   (1 << TC10)
#define TC10_L                   (0 << TC10)
#define TC11                      1
#define TC11_MSK                 (1 << TC11)
#define TC11_H                   (1 << TC11)
#define TC11_L                   (0 << TC11)
#define TC12                      2
#define TC12_MSK                 (1 << TC12)
#define TC12_H                   (1 << TC12)
#define TC12_L                   (0 << TC12)
#define TC13                      3
#define TC13_MSK                 (1 << TC13)
#define TC13_H                   (1 << TC13)
#define TC13_L                   (0 << TC13)
#define TC14                      4
#define TC14_MSK                 (1 << TC14)
#define TC14_H                   (1 << TC14)
#define TC14_L                   (0 << TC14)
#define TC15                      5
#define TC15_MSK                 (1 << TC15)
#define TC15_H                   (1 << TC15)
#define TC15_L                   (0 << TC15)
#define TC16                      6
#define TC16_MSK                 (1 << TC16)
#define TC16_H                   (1 << TC16)
#define TC16_L                   (0 << TC16)
#define TC17                      7
#define TC17_MSK                 (1 << TC17)
#define TC17_H                   (1 << TC17)
#define TC17_L                   (0 << TC17)

//// PT1PU //
#define PU10                      0
#define PU10_MSK                 (1 << PU10)
#define PU10_H                   (1 << PU10)
#define PU10_L                   (0 << PU10)
#define PU11                      1
#define PU11_MSK                 (1 << PU11)
#define PU11_H                   (1 << PU11)
#define PU11_L                   (0 << PU11)
#define PU12                      2
#define PU12_MSK                 (1 << PU12)
#define PU12_H                   (1 << PU12)
#define PU12_L                   (0 << PU12)
#define PU13                      3
#define PU13_MSK                 (1 << PU13)
#define PU13_H                   (1 << PU13)
#define PU13_L                   (0 << PU13)
#define PU14                      4
#define PU14_MSK                 (1 << PU14)
#define PU14_H                   (1 << PU14)
#define PU14_L                   (0 << PU14)
#define PU15                      5
#define PU15_MSK                 (1 << PU15)
#define PU15_H                   (1 << PU15)
#define PU15_L                   (0 << PU15)
#define PU16                      6
#define PU16_MSK                 (1 << PU16)
#define PU16_H                   (1 << PU16)
#define PU16_L                   (0 << PU16)
#define PU17                      7
#define PU17_MSK                 (1 << PU17)
#define PU17_H                   (1 << PU17)
#define PU17_L                   (0 << PU17)

//// PT1IN //
#define IN10                      0
#define IN10_MSK                 (1 << IN10)
#define IN10_H                   (1 << IN10)
#define IN10_L                   (0 << IN10)
#define IN11                      1
#define IN11_MSK                 (1 << IN11)
#define IN11_H                   (1 << IN11)
#define IN11_L                   (0 << IN11)
#define IN12                      2
#define IN12_MSK                 (1 << IN12)
#define IN12_H                   (1 << IN12)
#define IN12_L                   (0 << IN12)
#define IN13                      3
#define IN13_MSK                 (1 << IN13)
#define IN13_H                   (1 << IN13)
#define IN13_L                   (0 << IN13)
#define IN14                      4
#define IN14_MSK                 (1 << IN14)
#define IN14_H                   (1 << IN14)
#define IN14_L                   (0 << IN14)
#define IN15                      5
#define IN15_MSK                 (1 << IN15)
#define IN15_H                   (1 << IN15)
#define IN15_L                   (0 << IN15)
#define IN16                      6
#define IN16_MSK                 (1 << IN16)
#define IN16_H                   (1 << IN16)
#define IN16_L                   (0 << IN16)
#define IN17                      7
#define IN17_MSK                 (1 << IN17)
#define IN17_H                   (1 << IN17)
#define IN17_L                   (0 << IN17)

//// PT2 //
#define PT20                      0
#define PT20_MSK                 (1 << PT20)
#define PT20_H                   (1 << PT20)
#define PT20_L                   (0 << PT20)
#define PT21                      1
#define PT21_MSK                 (1 << PT21)
#define PT21_H                   (1 << PT21)
#define PT21_L                   (0 << PT21)
#define PT22                      2
#define PT22_MSK                 (1 << PT22)
#define PT22_H                   (1 << PT22)
#define PT22_L                   (0 << PT22)
#define PT23                      3
#define PT23_MSK                 (1 << PT23)
#define PT23_H                   (1 << PT23)
#define PT23_L                   (0 << PT23)

//// TRISC2 //
#define TC20                      0
#define TC20_MSK                 (1 << TC20)
#define TC20_H                   (1 << TC20)
#define TC20_L                   (0 << TC20)
#define TC21                      1
#define TC21_MSK                 (1 << TC21)
#define TC21_H                   (1 << TC21)
#define TC21_L                   (0 << TC21)
#define TC22                      2
#define TC22_MSK                 (1 << TC22)
#define TC22_H                   (1 << TC22)
#define TC22_L                   (0 << TC22)
#define TC23                      3
#define TC23_MSK                 (1 << TC23)
#define TC23_H                   (1 << TC23)
#define TC23_L                   (0 << TC23)

//// PT2PU //
#define PU20                      0
#define PU20_MSK                 (1 << PU20)
#define PU20_H                   (1 << PU20)
#define PU20_L                   (0 << PU20)
#define PU21                      1
#define PU21_MSK                 (1 << PU21)
#define PU21_H                   (1 << PU21)
#define PU21_L                   (0 << PU21)
#define PU22                      2
#define PU22_MSK                 (1 << PU22)
#define PU22_H                   (1 << PU22)
#define PU22_L                   (0 << PU22)
#define PU23                      3
#define PU23_MSK                 (1 << PU23)
#define PU23_H                   (1 << PU23)
#define PU23_L                   (0 << PU23)

//// PT2IN //
#define IN20                      0
#define IN20_MSK                 (1 << IN20)
#define IN20_H                   (1 << IN20)
#define IN20_L                   (0 << IN20)
#define IN21                      1
#define IN21_MSK                 (1 << IN21)
#define IN21_H                   (1 << IN21)
#define IN21_L                   (0 << IN21)
#define IN22                      2
#define IN22_MSK                 (1 << IN22)
#define IN22_H                   (1 << IN22)
#define IN22_L                   (0 << IN22)
#define IN23                      3
#define IN23_MSK                 (1 << IN23)
#define IN23_H                   (1 << IN23)
#define IN23_L                   (0 << IN23)

//// PT3 //
#define PT35                      5
#define PT35_MSK                 (1 << PT35)
#define PT35_H                   (1 << PT35)
#define PT35_L                   (0 << PT35)
#define PT36                      6
#define PT36_MSK                 (1 << PT36)
#define PT36_H                   (1 << PT36)
#define PT36_L                   (0 << PT36)

//// TRISC3 //
#define TC35                      5
#define TC35_MSK                 (1 << TC35)
#define TC35_H                   (1 << TC35)
#define TC35_L                   (0 << TC35)
#define TC36                      6
#define TC36_MSK                 (1 << TC36)
#define TC36_H                   (1 << TC36)
#define TC36_L                   (0 << TC36)

//// PT3PU //
#define PU35                      5
#define PU35_MSK                 (1 << PU35)
#define PU35_H                   (1 << PU35)
#define PU35_L                   (0 << PU35)
#define PU36                      6
#define PU36_MSK                 (1 << PU36)
#define PU36_H                   (1 << PU36)
#define PU36_L                   (0 << PU36)

//// PT3IN //
#define IN35                      5
#define IN35_MSK                 (1 << IN35)
#define IN35_H                   (1 << IN35)
#define IN35_L                   (0 << IN35)
#define IN36                      6
#define IN36_MSK                 (1 << IN36)
#define IN36_H                   (1 << IN36)
#define IN36_L                   (0 << IN36)

//// PT8 //
#define PT80                      0
#define PT80_MSK                 (1 << PT80)
#define PT80_H                   (1 << PT80)
#define PT80_L                   (0 << PT80)
#define PT81                      1
#define PT81_MSK                 (1 << PT81)
#define PT81_H                   (1 << PT81)
#define PT81_L                   (0 << PT81)
#define PT82                      2  
#define PT82_MSK                 (1 << PT82)
#define PT82_H                   (1 << PT82)
#define PT82_L                   (0 << PT82)
#define PT83                      3
#define PT83_MSK                 (1 << PT83)
#define PT83_H                   (1 << PT83)
#define PT83_L                   (0 << PT83)
#define PT84                      4
#define PT84_MSK                 (1 << PT84)
#define PT84_H                   (1 << PT84)
#define PT84_L                   (0 << PT84)
#define PT85                      5
#define PT85_MSK                 (1 << PT85)
#define PT85_H                   (1 << PT85)
#define PT85_L                   (0 << PT85)
#define PT86                      6
#define PT86_MSK                 (1 << PT86)
#define PT86_H                   (1 << PT86)
#define PT86_L                   (0 << PT86)
#define PT87                      7
#define PT87_MSK                 (1 << PT87)
#define PT87_H                   (1 << PT87)
#define PT87_L                   (0 << PT87)

//// TRISC8 //
#define TC80                      0
#define TC80_MSK                 (1 << TC80)
#define TC80_H                   (1 << TC80)
#define TC80_L                   (0 << TC80)
#define TC81                      1
#define TC81_MSK                 (1 << TC81)
#define TC81_H                   (1 << TC81)
#define TC81_L                   (0 << TC81)
#define TC82                      2
#define TC82_MSK                 (1 << TC82)
#define TC82_H                   (1 << TC82)
#define TC82_L                   (0 << TC82)
#define TC83                      3
#define TC83_MSK                 (1 << TC83)
#define TC83_H                   (1 << TC83)
#define TC83_L                   (0 << TC83)
#define TC84                      4
#define TC84_MSK                 (1 << TC84)
#define TC84_H                   (1 << TC84)
#define TC84_L                   (0 << TC84)
#define TC85                      5
#define TC85_MSK                 (1 << TC85)
#define TC85_H                   (1 << TC85)
#define TC85_L                   (0 << TC85)
#define TC86                      6
#define TC86_MSK                 (1 << TC86)
#define TC86_H                   (1 << TC86)
#define TC86_L                   (0 << TC86)
#define TC87                      7
#define TC87_MSK                 (1 << TC87)
#define TC87_H                   (1 << TC87)
#define TC87_L                   (0 << TC87)

//// PT8PU //
#define PU80                      0
#define PU80_MSK                 (1 << PU80)
#define PU80_H                   (1 << PU80)
#define PU80_L                   (0 << PU80)
#define PU81                      1
#define PU81_MSK                 (1 << PU81)
#define PU81_H                   (1 << PU81)
#define PU81_L                   (0 << PU81)
#define PU82                      2
#define PU82_MSK                 (1 << PU82)
#define PU82_H                   (1 << PU82)
#define PU82_L                   (0 << PU82)
#define PU83                      3
#define PU83_MSK                 (1 << PU83)
#define PU83_H                   (1 << PU83)
#define PU83_L                   (0 << PU83)
#define PU84                      4
#define PU84_MSK                 (1 << PU84)
#define PU84_H                   (1 << PU84)
#define PU84_L                   (0 << PU84)
#define PU85                      5
#define PU85_MSK                 (1 << PU85)
#define PU85_H                   (1 << PU85)
#define PU85_L                   (0 << PU85)
#define PU86                      6
#define PU86_MSK                 (1 << PU86)
#define PU86_H                   (1 << PU86)
#define PU86_L                   (0 << PU86)
#define PU87                      7
#define PU87_MSK                 (1 << PU87)
#define PU87_H                   (1 << PU87)
#define PU87_L                   (0 << PU87)

//// PT8IN //
#define IN80                      0
#define IN80_MSK                 (1 << IN80)
#define IN80_H                   (1 << IN80)
#define IN80_L                   (0 << IN80)
#define IN81                      1
#define IN81_MSK                 (1 << IN81)
#define IN81_H                   (1 << IN81)
#define IN81_L                   (0 << IN81)
#define IN82                      2
#define IN82_MSK                 (1 << IN82)
#define IN82_H                   (1 << IN82)
#define IN82_L                   (0 << IN82)
#define IN83                      3
#define IN83_MSK                 (1 << IN83)
#define IN83_H                   (1 << IN83)
#define IN83_L                   (0 << IN83)
#define IN84                      4
#define IN84_MSK                 (1 << IN84)
#define IN84_H                   (1 << IN84)
#define IN84_L                   (0 << IN84)
#define IN85                      5
#define IN85_MSK                 (1 << IN85)
#define IN85_H                   (1 << IN85)
#define IN85_L                   (0 << IN85)
#define IN86                      6
#define IN86_MSK                 (1 << IN86)
#define IN86_H                   (1 << IN86)
#define IN86_L                   (0 << IN86)
#define IN87                      7
#define IN87_MSK                 (1 << IN87)
#define IN87_H                   (1 << IN87)
#define IN87_L                   (0 << IN87)

//// PT1M1 //
#define INTEG0                    0
#define INTEG0_MSK               (3 << INTEG0)
#define INTEG0_LEV               (3 << INTEG0)
//#define INTEG0_LEV             (2 << INTEG0)
#define INTEG0_EDGERISE          (1 << INTEG0)
#define INTEG0_EDGEFALL          (0 << INTEG0)

#define INTEG1                    2
#define INTEG1_MSK               (3 << INTEG1)
#define INTEG1_LEV               (3 << INTEG1)
//#define INTEG1_LEV             (2 << INTEG1)
#define INTEG1_EDGERISE          (1 << INTEG1)
#define INTEG1_EDGEFALL          (0 << INTEG1)

//// PT1INT //
#define INTEG2                    2
#define INTEG2_MSK               (1 << INTEG2)
#define INTEG2_EDGERISE          (1 << INTEG2)
#define INTEG2_EDGEFALL          (0 << INTEG2)

#define INTEG3                    3
#define INTEG3_MSK               (1 << INTEG3)
#define INTEG3_EDGERISE          (1 << INTEG3)
#define INTEG3_EDGEFALL          (0 << INTEG3)

#define INTEG4                    4
#define INTEG4_MSK               (1 << INTEG4)
#define INTEG4_EDGERISE          (1 << INTEG4)
#define INTEG4_EDGEFALL          (0 << INTEG4)

#define INTEG5                    5
#define INTEG5_MSK               (1 << INTEG5)
#define INTEG5_EDGERISE          (1 << INTEG5)
#define INTEG5_EDGEFALL          (0 << INTEG5)

#define INTEG6                    6
#define INTEG6_MSK               (1 << INTEG6)
#define INTEG6_EDGERISE          (1 << INTEG6)
#define INTEG6_EDGEFALL          (0 << INTEG6)

#define INTEG7                    7
#define INTEG7_MSK               (1 << INTEG7)
#define INTEG7_EDGERISE          (1 << INTEG7)
#define INTEG7_EDGEFALL          (0 << INTEG7)

//// PT2INT //
#define INTG20                    0
#define INTG20_MSK               (1 << INTG20)
#define INTG20_EDGERISE          (1 << INTG20)
#define INTG20_EDGEFALL          (0 << INTG20)

#define INTG21                    1
#define INTG21_MSK               (1 << INTG21)
#define INTG21_EDGERISE          (1 << INTG21)
#define INTG21_EDGEFALL          (0 << INTG21)

#define INTG22                    2
#define INTG22_MSK               (1 << INTG22)
#define INTG22_EDGERISE          (1 << INTG22)
#define INTG22_EDGEFALL          (0 << INTG22)

#define INTG23                    3
#define INTG23_MSK               (1 << INTG23)
#define INTG23_EDGERISE          (1 << INTG23)
#define INTG23_EDGEFALL          (0 << INTG23)
/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
// Peripherals/GPIO Multiplexing Config for Peripherals were placed in each peripheral module
// individually GPIO Config were declared/defined below

//// PT1.x // x=0~7
#define GPIO_PT1OutputMode(BitSet)           (TRISC1 |= (1 << BitSet))
#define GPIO_PT1InputMode(BitSet)            (TRISC1 &= ~(1 << BitSet))
#define GPIO_PT1SETPU(BitSet)                (PT1PU |= (1 << BitSet))
#define GPIO_PT1CLRPU(BitSet)                (PT1PU &= ~(1 << BitSet))
#define GPIO_PT1SETIN(BitSet)                (PT1IN |= (1 << BitSet))
#define GPIO_PT1CLRIN(BitSet)                (PT1IN &= ~(1 << BitSet))
#define GPIO_PT1GET(BitSet)                  (PT1 & (1 <<BitSet))
#define GPIO_PT1SET(BitSet)                  (PT1 |= (1 << BitSet))
#define GPIO_PT1CLR(BitSet)                  (PT1 &= ~(1 << BitSet))

//// PT2.x // x=0~3
#define GPIO_PT2OutputMode(BitSet)           (TRISC2 |= (1 << BitSet))
#define GPIO_PT2InputMode(BitSet)            (TRISC2 &= ~(1 << BitSet))
#define GPIO_PT2SETPU(BitSet)                (PT2PU |= (1 << BitSet))
#define GPIO_PT2CLRPU(BitSet)                (PT2PU &= ~(1 << BitSet))
#define GPIO_PT2SETIN(BitSet)                (PT2IN |= (1 << BitSet))
#define GPIO_PT2CLRIN(BitSet)                (PT2IN &= ~(1 << BitSet))
#define GPIO_PT2GET(BitSet)                  (PT2 & (1 <<BitSet))
#define GPIO_PT2SET(BitSet)                  (PT2 |= (1 << BitSet))
#define GPIO_PT2CLR(BitSet)                  (PT2 &= ~(1 << BitSet))

//PT3.x // x=5~6
#define GPIO_PT3OutputMode(BitSet)           (TRISC3 |= (1 << BitSet))
#define GPIO_PT3InputMode(BitSet)            (TRISC3 &= ~(1 << BitSet))
#define GPIO_PT3SETPU(BitSet)                (PT3PU |= (1 << BitSet))
#define GPIO_PT3CLRPU(BitSet)                (PT3PU &= ~(1 << BitSet))
#define GPIO_PT3SETIN(BitSet)                (PT3IN |= (1 << BitSet))
#define GPIO_PT3CLRIN(BitSet)                (PT3IN &= ~(1 << BitSet))
#define GPIO_PT3GET(BitSet)                  (PT3 & (1 <<BitSet))
#define GPIO_PT3SET(BitSet)                  (PT3 |= (1 << BitSet))
#define GPIO_PT3CLR(BitSet)                  (PT3 &= ~(1 << BitSet))

//PT8.x // x=0~7
#define GPIO_PT8OutputMode(BitSet)           (TRISC8 |= (1 << BitSet))
#define GPIO_PT8InputMode(BitSet)            (TRISC8 &= ~(1 << BitSet))
#define GPIO_PT8SETPU(BitSet)                (PT8PU |= (1 << BitSet))
#define GPIO_PT8CLRPU(BitSet)                (PT8PU &= ~(1 << BitSet))
#define GPIO_PT8SETIN(BitSet)                (PT8IN |= (1 << BitSet))
#define GPIO_PT8CLRIN(BitSet)                (PT8IN &= ~(1 << BitSet))
#define GPIO_PT8GET(BitSet)                  (PT8 & (1 <<BitSet))
#define GPIO_PT8SET(BitSet)                  (PT8 |= (1 << BitSet))
#define GPIO_PT8CLR(BitSet)                  (PT8 &= ~(1 << BitSet))


#define GPIO_INTEG0Sel(EG0Sel)               (PT1M1 = ((PT1M1 & (~INTEG0_MSK)) | EG0Sel))
#define GPIO_INTEG1Sel(EG1Sel)               (PT1M1 = ((PT1M1 & (~INTEG1_MSK)) | EG1Sel))
#define GPIO_INTEG2Sel(EG2Sel)                (PT1INT = ((PT1INT & (~INTEG2_MSK )) | EG2Sel))
#define GPIO_INTEG3Sel(EG3Sel)                (PT1INT = ((PT1INT & (~INTEG3_MSK )) | EG3Sel))
#define GPIO_INTEG4Sel(EG4Sel)                (PT1INT = ((PT1INT & (~INTEG4_MSK )) | EG4Sel))
#define GPIO_INTEG5Sel(EG5Sel)                (PT1INT = ((PT1INT & (~INTEG5_MSK )) | EG5Sel))
#define GPIO_INTEG6Sel(EG6Sel)                (PT1INT = ((PT1INT & (~INTEG6_MSK )) | EG6Sel))
#define GPIO_INTEG7Sel(EG7Sel)                (PT1INT = ((PT1INT & (~INTEG7_MSK )) | EG7Sel))

#define GPIO_INTG20Sel(EG20Sel)                (PT2INT = ((PT2INT & (~INTG20_MSK )) | EG20Sel))
#define GPIO_INTG21Sel(EG21Sel)                (PT2INT = ((PT2INT & (~INTG21_MSK )) | EG21Sel))
#define GPIO_INTG22Sel(EG22Sel)                (PT2INT = ((PT2INT & (~INTG22_MSK )) | EG22Sel))
#define GPIO_INTG23Sel(EG23Sel)                (PT2INT = ((PT2INT & (~INTG23_MSK )) | EG23Sel))

#define GPIO_PT1SETPUAll()                   (PT1PU = 0xff)
#define GPIO_PT2SETPUAll()                   (PT2PU = 0xff)
#define GPIO_PT3SETPUAll()                   (PT3PU = 0xff)
#define GPIO_PT8SETPUAll()                   (PT8PU = 0xff)