/**************************************************************************************************|
|* Copyright 2020 Hycon Technology, Corp.                                                          *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY17P6X Series                                                                 *|
|**************************************************************************************************/


/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
// OP1CN0 //
#define ENOP1                    7
#define ENOP1_MSK               (1 << ENOP1)
#define ENOP1_ENABLE            (1 << ENOP1)
#define ENOP1_DISABLE           (0 << ENOP1)

#define SOP1P                    4
#define SOP1P_MSK               (7 << SOP1P)
//#define SOP1P_                (7 << SOP1P)
#define SOP1P_PB3               (6 << SOP1P)
//#define SOP1P_                (5 << SOP1P)
#define SOP1P_PB0               (4 << SOP1P)
#define SOP1P_AGND              (3 << SOP1P)
//#define SOP1P_                (2 << SOP1P)
//#define SOP1P_                (1 << SOP1P)
//#define SOP1P_                (0 << SOP1P)

#define HS                       1
#define HS_MSK                  (1 << HS)
#define HS_ENABLE               (1 << HS)
#define HS_DISABLE              (0 << HS)

#define OPS1                    0
#define OPS1_MSK               (1 << ENOP1)
#define OPS1_OP1N              (1 << ENOP1)
#define OPS1_OP1O              (0 << ENOP1)


/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/

/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
#define OP1_Enable()             (OP1CN0 |= ENOP1_ENABLE)
#define OP1_Disable()            (OP1CN0 &= (~ENOP1_MSK))

#define OP1_INPSelect(inp)       (OP1CN0 = ((OP1CN0 & (~SOP1P_MSK)) | inp

#define OP1_HighSpeedEnable()    (OP1CN0 |= HS_ENABLE)
#define OP1_HighSpeedDisable()   (OP1CN0 &= (~HS_MSK))

#define OP1_NonInvertingAMP      (OP1CN0 |= OPS1_OP1N)
#define OP1_UnityGainBuffer      (OP1CN0 &= (~HS_MSK))

/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
	   				